#include "C99_Tasking64_Parser.h"
#include <iostream>
using namespace std;

int C99_Tasking64_Parser::yylex()
{
	yylloc.first_line = scanner.get_line();
	yylloc.first_column = scanner.get_column();
	int token = scanner.yylex(&yylval, &yylloc);
	yylloc.last_line = scanner.get_line();
	yylloc.last_column = scanner.get_column();
	yylloc.text = scanner.yytext;
	return token;
}

void C99_Tasking64_Parser::yyerror(char * msg)
{
	cerr << yylloc.first_line << ":" << yylloc.first_column
		<< ": " << msg << " : " << yylloc.text << endl;
}

void C99_Tasking64_Parser::add_type(const std::string & type)
{
	scanner.add_type(type);
}

void C99_Tasking64_Parser::set_current_module(const std::string & module)
{
	scanner.set_current_module(module);
}

std::string C99_Tasking64_Parser::module() const
{
	return scanner.get_current_module();
}

std::string C99_Tasking64_Parser::name()
{
	return std::string("C99_Tasking64");
}

int C99_Tasking64_Parser::parse(std::istream & is, const std::string & module, SyntaxTree * tree)
{
	if (!tree) return -1;
	this->tree = tree;
// ## DEBUG ## yydebug = 1;
	std::streambuf * old_cin = cin.rdbuf();
	cin.rdbuf(is.rdbuf());
	set_parsed_module(module);
	scanner.set_current_module(module);
	scanner.init();
	cin.clear();
	int result = yyparse();
	cin.rdbuf(old_cin);
	return result;
}
