#include "Node.h"

size_t Node::objects = 0;

Node::Node(const Node & node)
	: type(type), root(0), module(""), data_identifier(""), data_character(0)
{
	++objects;
}

Node::Node(int type)
	: type(type), root(0), module(""), data_identifier(""), data_character(0)
{
	module.reserve(0);
	++objects;
}

Node::Node(int type, const char * identifier)
	: type(type), root(0), module(""), data_identifier(identifier), data_character(0)
{
	module.reserve(0);
	++objects;
}

Node::Node(int type, char character)
	: type(type), root(0), module(""), data_identifier(""), data_character(character)
{
	module.reserve(0);
	++objects;
}

Node::Node(int type, const std::string & module)
	: type(type), root(0), module(module), data_identifier(""), data_character(0)
{
	++objects;
}

Node::Node(int type, const std::string & identifier, const std::string & module)
	: type(type), root(0), module(module), data_identifier(identifier), data_character(0)
{
	++objects;
}

Node::Node(int type, char character, const std::string & module)
	: type(type), root(0), module(module), data_identifier(""), data_character(character)
{
	++objects;
}

size_t Node::count_nodes(const Node * root) const
{
	if (!root) return 0;
	size_t res = 1;
	for (const_iterator i = root->sub.begin(); i != root->sub.end(); ++i) res += count_nodes(*i);
	return res;
}

