#include "SyntaxTree.h"

SyntaxTree::SyntaxTree()
{
}

SyntaxTree::SyntaxTree(const SyntaxTree &)
{}

SyntaxTree::~SyntaxTree()
{
	clear();
}

void SyntaxTree::clear()
{
	while (!stack.empty()) delete pop();
}

size_t SyntaxTree::count_nodes() const
{
	size_t res = 0;
	for (const_iterator i = stack.begin(); i != stack.end(); ++i) res += (*i)->count_nodes();
	return res;
}

size_t SyntaxTree::size() const
{
	return stack.size();
}

Node * SyntaxTree::pop()
{
	Node * node = stack.back();
	stack.pop_back();
	return node;
}

void SyntaxTree::push(Node * node)
{
	stack.push_back(node);
}

Node * SyntaxTree::operator[] (int i) const
{
	return stack[i];
}

SyntaxTree::const_iterator SyntaxTree::begin() const
{
	return stack.begin();
}

SyntaxTree::const_iterator SyntaxTree::end() const
{
	return stack.end();
}

SyntaxTree::const_reverse_iterator SyntaxTree::rbegin() const
{
	return stack.rbegin();
}

SyntaxTree::const_reverse_iterator SyntaxTree::rend() const
{
	return stack.rend();
}

