#ifndef __SYNTAXTREE_H__
#define __SYNTAXTREE_H__

#include <vector>
#include "Node.h"

class SyntaxTree
{
	private:
		typedef std::vector<Node *> NContainer;
	public:
		typedef NContainer::const_iterator const_iterator;
		typedef NContainer::const_reverse_iterator const_reverse_iterator;
	private:
		NContainer stack;
	private:
		SyntaxTree(const SyntaxTree &);
		void clear();
	public:
		typedef std::vector<SyntaxTree *> STVec;
	public:
		SyntaxTree();
		~SyntaxTree();

		// tree methods
		size_t count_nodes() const;
		size_t size() const;
		Node * pop();
		void push(Node *);

		// accessors
		Node * operator[] (int) const;
		const_iterator begin() const;
		const_iterator end() const;
		const_reverse_iterator rbegin() const;
		const_reverse_iterator rend() const;
};

#endif
