#include "stringutils.h"

#define WHTIE_SPACES  (" \r\n\t\f")

std::string & trim_in_place(std::string & s)
{
	s.erase(0, s.find_first_not_of(WHTIE_SPACES));
	s.erase(s.find_last_not_of(WHTIE_SPACES)+1);
	return s;
}

std::string trim(const std::string & str)
{
	std::string s(str);
	return trim_in_place(s);
}

std::string replace_const(const std::string & str, const std::string & org_str, const std::string & new_str)
{
	std::string s(str);
	return replace(s, org_str, new_str);
}

std::string & replace(std::string & s, const std::string & org_str, const std::string & new_str)
{
	size_t i = 0;
	while ((i = s.find(org_str, i)) != std::string::npos)
	{
		s.replace(i, org_str.size(), new_str);
		i += new_str.size();
	}
	return s;
}

std::string & remove_quotes(std::string & str)
{
	if (str[0] == '"' && str[str.size()-1] == '"')
	{
		str.erase(--str.end());
		str.erase(str.begin());
	}
	return str;
}
